#ifdef LIGHT_SENSOR_HID
      Device(ALSD){                             // Ambient Light Sensor
        Name(_ADR, 0x0)
        Name(_HID, LIGHT_SENSOR_HID)
        Name(_CID, LIGHT_SENSOR_HID)
        Name(_UID, 0x1)
		Method(_STA, 0x0, NotSerialized)
		{
			return(0x0f)
		}
        Method(_CRS, 0x0, NotSerialized)
        {
          Name(SBUF, ResourceTemplate()
          {
			I2CSerialBus( 0x0C,, I2C_SPEED,, "\\_SB.I2C1",,,,)		  
            //
            // Ambient Light Sensor I2C descriptor.
            //
            I2CSerialBus( LIGHT_SENSOR_ADDR,, I2C_SPEED,, "\\_SB.I2C1",,,,)
            //
            // GPIO Interrupt descriptor
            GpioInt( Level, ActiveLow, Exclusive, PullDefault, 0, "\\_SB.GPIO", ) {ACPI_GPIO_X3}
          })
          Return (SBUF)
        }

        // Initial setting
        Name(CPM0, Package(0x7)
        {
          3218,0,0xF,0x0844,0x0318,0x01F4,0x0
        })

        // Calibration data
        Name(CPM1, Package(0x3)
        {
          1428, 2000000, 100000
          //-> 64bit, 64bit, 64bit LB
        })

        // Sensitivity factor
        Name(CPM2, Package(0x6)
        {
          25000,100000,100000,100000,200000,400000
        })

        // ALR curve
        Name(CPM3, Package()
        {
          Package() {70, 0},     // Min          ( -30% adjust at    0 lux)
          Package() {73, 10},    //              ( -27% adjust at   10 lux)
          Package() {85, 80},    //              ( -15% adjust at   80 lux)
          Package() {100,300},   // Baseline     (   0% adjust at  300 lux)
          Package() {150,1000}   // Max          ( +50% adjust at 1000 lux)
        })

        // Default property
        Name(CPM5, Package(0x7)
        {
          0,150000,400,1000,2,25,5
        })

        Method(_DSM, 0x4, NotSerialized)
        {
          If(LEqual(Arg0, Buffer(0x10)
          {
            0xB6, 0xC6, 0x03, 0x07, 0xCA, 0x1C, 0x44, 0x41, 0x9F, 0xE7, 0x46, 0x54,	0xF5, 0x3A, 0x0B, 0xD9
          }))
          {
            If(LEqual(Arg2, 0x0))
            {
              Return(Buffer(0x1)
              {
                0x03
              })
            }
            If(LEqual(Arg2, 0x1))
            {
              If(LEqual(ToInteger(Arg3, ), 0x0))
              {
                Return(CPM0)
              }
              If(LEqual(ToInteger(Arg3, ), 0x1))
              {
                Store(ALS0, Index(CMP1,2))
                Store(ALS1, Index(CMP1,1))
                Store(ALS2, Index(CMP1,0))
                Return(CPM1)
              }
              If(LEqual(ToInteger(Arg3, ), 0x2))
              {
                Return(CPM2)
              }
              If(LEqual(ToInteger(Arg3, ), 0x3))
              {
                Return(CPM3)
              }
              If(LEqual(ToInteger(Arg3, ), 0x5))
              {
                Return(CPM5)
              }
            }
          }
          Return(Buffer(One)
          {
            0x0
          })
        }
      } // End Device.
#endif